<?php
// 変数設定
// 自動発番する値の設定
$PREFIX = "ID"; // 接頭文字
$SUFFIX = ""; // 接尾文字
$IDREG = "10"; // ID何桁で0埋めするか

// API設定
$APIKEY = ""; // APIキー
$DBID = ""; // DBID
$BLOCKSYM = ""; // 登録フォームブロックの識別名

$AUTID = ""; // 自動発番値を格納するフィールドの識別名
$EMAIL = ""; // メールアドレスフィールドの識別名
$EMAILID = ""; // メールアドレスフィールドのID
$TENTA = ""; //　仮メールアドレスフィールドの識別名

// APIメール送信設定
$MAILFLG = "0"; // 発番した値を含む完了メールを配信したい場合1　配信しない場合0
$APIMAIL = ""; // APIメール送信フィールドの識別名
$APPID = ""; // アプリID
$ACTIONID = ""; // メールアクションID

// ーーーー以下は変更しないでくださいーーーー
$param = "f0". $EMAILID;
$paramVal = $SPIRAL->getParam($param);

$registForm = $SPIRAL->getRegistrationForm($BLOCKSYM);
$completFlg = $registForm->isCompletedStep();

$base_url = "https://api.spiral-platform.com/v1/";
$header = array(
    "Authorization:Bearer ".$APIKEY,
    "Content-Type:application/json",
    "X-Spiral-App-Authority:"."manage",
);

if ($completFlg) {
    $api_result = array();
    $SPIRAL->setTHValue("APIERRORFLAG", "ok");

    $q_where = "&where=@". $AUTID. "='". $paramVal. "'";
    $query = "?limit=1". $q_where;
    $se_result = selectRecords($base_url, $DBID, $header, $query);
    if (array_key_exists('status', $se_result)){
        if ($se_result["status"] != 200){
            $SPIRAL->setTHValue("APIERRORFLAG", "error");
            return;
        }
    }

    $record_id = $se_result["items"][0]["_id"];
    $new_id = str_pad($record_id, $IDREG, 0, STR_PAD_LEFT);
    $new_id = $PREFIX. $new_id. $SUFFIX;
    $updata = array( $AUTID => $new_id );
    if ($EMAIL !== "" && $TENTA !== "") {
        $updata[$EMAIL] = $se_result["items"][0][$TENTA];
        $updata[$TENTA] = null;
    }
    if ($APIMAIL !== "" && $MAILFLG === "1") {
        $updata[$APIMAIL] = "APIメール送信可能";
    }
    $up_result = updateRecords($base_url, $DBID, $header, $updata, $record_id);
    if (array_key_exists('status', $up_result)){
        if ($up_result["status"] != 200){
            $SPIRAL->setTHValue("APIERRORFLAG", "error");
            return;
        }
    }

    if ($MAILFLG === "1") {
        $data = array("recordId" => $record_id);
        $ac_result = runAction($base_url, $APPID, $header, $data, $ACTIONID);
    }
}

function selectRecords($base_url, $DBID, $header, $query) {
    $url = $base_url."dbs/". $DBID. "/records". $query;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_URL , $url);
    curl_setopt($curl, CURLOPT_HTTPHEADER , $header);
    $response = curl_exec($curl);
    if (curl_errno($curl)) echo curl_error($curl);
    curl_close($curl);
    $result = json_decode($response , true);
    return $result;
}
function updateRecords($base_url, $DBID, $header, $data, $record_id) {
    $url = $base_url."dbs/". $DBID. "/records/". $record_id;
    $json_body = json_encode($data);
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_URL , $url);
    curl_setopt($curl, CURLOPT_HTTPHEADER , $header);
    curl_setopt($curl, CURLOPT_POSTFIELDS , $json_body);
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST , 'PATCH');
    $response = curl_exec($curl);
    if (curl_errno($curl)) echo curl_error($curl);
    curl_close($curl);
    $result = json_decode($response , true);
    return $result;
}
function runAction($base_url, $APPID, $header, $data, $ACTIONID) {
    $url = $base_url."apps/". $APPID. "/actions/". $ACTIONID. "/run";
    $json_body = json_encode($data);
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_URL , $url);
    curl_setopt($curl, CURLOPT_HTTPHEADER , $header);
    curl_setopt($curl, CURLOPT_POSTFIELDS , $json_body);
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST , 'POST');
    $response = curl_exec($curl);
    if (curl_errno($curl)) echo curl_error($curl);
    curl_close($curl);
    $result = json_decode($response , true);
    return $result;
}
?>